<section id="job_header" class="content-header">
  <div class="row">
    <div class="col-sm-6 padding-left-5">
      <input kendoInput type="text" id="job_name" class="job_name" placeholder="New Jobs"
        [(ngModel)]="jobRequest.jobName" />
    </div>
    <div kendoTooltip class="col-sm-6 padding-right-5">
      <button kendoButton class="pull-right" (click)="runJob()" *ngIf="!isRunEnabled">
        <svg title="Run Job" class="icon_connection" shape-rendering="geometricPrecision" width="20" height="20">
          <use xlink:href="./assets/dist/img/icons.svg#icon_play"></use>
        </svg>
      </button>
      <button kendoButton class="pull-right k-button-default" (click)="stopJob()" *ngIf="isRunEnabled">
        <svg title="Stop Job" class="icon_connection" shape-rendering="geometricPrecision" width="20" height="20">
          <use xlink:href="./assets/dist/img/icons.svg#icon_stop"></use>
        </svg>
      </button>
      <span>
        <button kendoButton id="saveBtn" class="pull-right k-button-default" (click)="saveJob()"
          [disabled]="jobRequest.jobName == ''">
          <svg title="Save Job" class="icon_connection" shape-rendering="geometricPrecision" width="20" height="20">
            <use xlink:href="./assets/dist/img/icons.svg#icon_save"></use>
          </svg>
        </button>
      </span>
      <button #scheduler title="Schedule Job" kendoTooltip kendoButton class="pull-right k-button-default"
        (click)="isSchedulerHide = !isSchedulerHide" [disabled]="jobRequest.jobId == ''">
        <svg class="icon_connection" shape-rendering="geometricPrecision" width="20" height="20">
          <use xlink:href="./assets/dist/img/icons.svg#icon_schedule"></use>
        </svg>
      </button>
      <button kendoTooltip title="View Log" kendoButton class="pull-right k-button-default" (click)="openTab('logView')"
        [disabled]="jobRequest.jobId == ''">
        <svg class="icon_connection" shape-rendering="geometricPrecision" width="20" height="20">
          <use xlink:href="./assets/dist/img/icons.svg#icon_log"></use>
        </svg>
      </button>
      <span class="pull-right" (click)="checkProgress(jobRequest.jobId)" style="margin: 10px">{{statsMessage}}</span>
      <kendo-popup [anchor]="scheduler" (anchorViewportLeave)="isSchedulerHide = false" *ngIf="isSchedulerHide"
        class="scheduler-popup" style="top: unset !important">
        <div>
          <cron-editor [(cron)]="cronExpression" [disabled]="isCronDisabled" [(options)]="cronOptions"></cron-editor>
          <hr />
          <p>Cron Expression: <strong>{{cronExpression}}</strong></p>
          <button kendoButton class="pull-right k-button-default" (click)="schduleJob()">Save</button>
        </div>
      </kendo-popup>
    </div>
  </div>
</section>
<section id="job_content">
  <div class="box box-warning box-solid" *ngIf="isSyncAble" style="box-shadow: 0px 5px 17px 1px rgba(0,0 ,0, 0.5);
      position: absolute;z-index: 100;width: 400px;left: 45%;">
    <div class="box-body" style="margin: 0;font-size: 12px;">
      <div *ngIf="isSyncAble">
        <p>Found few column in source table. Do you want to sync with target table metadata?
        </p>
        <div class="box-tools pull-right">
          <button kendoButton [primary]="true" (click)="getUpdatedTableMetadata()">Ok
          </button>&nbsp;
          <button type="button" class="btn btn-default btn-box-tool" (click)="isSyncAble = !isSyncAble"
            data-widget="collapse">Cancel
          </button>
        </div>
      </div>
    </div>
    <!-- /.box-body -->
  </div>
  <div class="col-sm-6 connection">
    <div class="row connection_header">
      <div class="col-lg-11">
        <span id="sourceConnections" data-position='top'>
          <kendo-dropdownlist [data]="sourceConnections" class="custom_dpd" height="40" [filterable]="true"
            [textField]="'name'" [valueField]="'connectionId'" (filterChange)="filterSourceConnection($event)"
            [(ngModel)]="sourceConnectionValue" *ngIf="!isSourceConnectionConnected"
            (selectionChange)="selectionChangeSourceConnection($event)">
          </kendo-dropdownlist>
        </span>
        <span id="sourceCollection">
          <kendo-dropdownlist [data]="sourceCollection" class="custom_dpd" height="40" [filterable]="true"
            [textField]="'text'" [valueField]="'value'" (filterChange)="filterSourceCollection($event)"
            [(ngModel)]="sourceCollectionValue" (selectionChange)="selectionChangeSourceCollection($event)"
            *ngIf="isSourceConnectionConnected" [disabled]= "sourceValueType === 'EXCEL'">
          </kendo-dropdownlist>
        </span>
      </div>
      <div class="col-lg-1 no-padding text-center">

        <span id="sourceConnectionsBtn">
          <button kendoButton class="k-button-default" *ngIf="!isSourceConnectionConnected"
            (click)="selectionChangeSourceConnection()">
            <svg class="icon_ok" shape-rendering="geometricPrecision" width="20" height="20" fill="#0067C5">
              <use xlink:href="./assets/dist/img/icons.svg#icon_ok"></use>
            </svg>
          </button>
        </span>
        <span id="openFilterBtn">
          <button #sourceConnection kendoButton class="k-button-default option"
            (click)="onToggleSourceConnection(isSourceConnectionOption)" *ngIf="isSourceConnectionConnected">
            <svg class="icon_connection" shape-rendering="geometricPrecision" width="20" height="20">
              <use xlink:href="./assets/dist/img/icons.svg#icon_vertical_dots"></use>
            </svg>
          </button>
        </span>
        <span id="filterBtn">
          <kendo-popup [anchor]="sourceConnection" (anchorViewportLeave)="isSourceConnectionOption = false"
            *ngIf="isSourceConnectionOption" class="source-connection-option" style="top: unset !important">
            <ul class="nav nav-list">
              <li>
                <a href="javascript:void(0)" (click)="changeSourceConnection()" class="changelog white">
                  <svg class="icon_change_log" shape-rendering="geometricPrecision" width="20" height="20">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_change_log"></use>
                  </svg> Change Connection
                </a>
              </li>
              <li>
                <a href="javascript:void(0)" *ngIf="isSourceConnectionConnected && isSourceCollectionSelected"
                  (click)="openTab('filter');onToggleSourceConnection(isSourceConnectionOption)"
                  class="changelog white">
                  <svg class="icon_update" shape-rendering="geometricPrecision" width="15" height="15">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_filter"></use>
                  </svg> Filter
                </a>
              </li>
              <li>
                <a href="javascript:void(0)" *ngIf="isSourceConnectionConnected && isSourceCollectionSelected"
                  (click)="openTab('netChange');onToggleSourceConnection(isSourceConnectionOption)"
                  class="changelog white">
                  <svg class="icon_update" shape-rendering="geometricPrecision" width="15" height="15">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_settings"></use>
                  </svg> Net Change
                </a>
              </li>
              <li>
                <a href="javascript:void(0)" *ngIf="isSourceConnectionConnected && isSourceCollectionSelected"
                  (click)="openTab('dataPreviewer')" class="changelog white">
                  <svg class="icon_update" shape-rendering="geometricPrecision" width="15" height="15">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_viwer"></use>
                  </svg> Data Previewer
                </a>
              </li>
              <li>
                <a href="javascript:void(0)" (click)="syncMetadata()" class="changelog white">
                  <svg class="icon_update" shape-rendering="geometricPrecision" width="15" height="15">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_refresh"></use>
                  </svg> Sync Metadata
                </a>
              </li>
              <li>
                <a href="javascript:void(0)" *ngIf="isSourceConnectionConnected && isSourceCollectionSelected"
                  (click)="refreshSourceMetadata()" class="changelog white">
                  <svg class="icon_update" shape-rendering="geometricPrecision" width="15" height="15">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_refresh"></use>
                  </svg> Refresh Metadata
                </a>
              </li>
            </ul>
          </kendo-popup>
        </span>
      </div>
    </div>
    <div class="connection_message">
      <div class="message1" *ngIf="!isSourceConnectionConnected">
        Choose source connection by clicking above icon
        <svg class="icon_add_item" shape-rendering="geometricPrecision" width="20" height="20" fill="#0067C5">
          <use xlink:href="./assets/dist/img/icons.svg#icon_add_item"></use>
        </svg>


      </div>
      <div class="message2" *ngIf="(isSourceConnectionConnected && !isSourceCollectionSelected) && sourceValueType!=='EXCEL'">
        Select collection name from above collection dropdown or Create new table.
      </div>
      <div class="message2" *ngIf="(isSourceConnectionConnected && !isSourceCollectionSelected) && sourceValueType==='EXCEL'">
          
          <input type='file' (change)="onSelectFile($event)">
      </div>
    </div>
    <div *ngIf="isSourceCollectionSelected">
      <div class="collection" *ngFor="let obj of selectedSourceCollection">
        <div class="name">
          <!-- <input type="checkbox" class="pull-left" style="width: unset" />  -->
          {{obj.collectionName}}

          <!-- <div class="pull-right">
              <input for="childObj" type="radio" [(ngModel)]="obj.toggleChildObject" [value]="true"
                (change)="obj.toggleChildObject = !obj.toggleChildObject" style=" width: unset" /><label
                id="childObj">Child
                Object</label>
            </div> -->
        </div>
        <div mwlDraggable [dropData]="metadata.name" (dragEnd)="dragEnd($event)" class="parameters"
          *ngFor="let metadata of obj.collectionMetadataResponseList">
          <div class="name">
            {{metadata.name}}
            <small class="label label-success" *ngIf="metadata.isNewColumn">New</small>
            <small class="label label-danger" *ngIf="metadata.isDeletedColumn">Delete</small>
          </div>
          <div class="type">
            {{metadata.type}}
          </div>
          <!-- <div mwlDraggable   (dragEnd)="dragEnd($event)" *ngFor="let track of obj.collectionMetadataResponseList">
            {{track}}
          </div> -->
        </div>

        <!-- {{obj.toggleChildObject}} -->
        <div *ngIf="obj.toggleChildObject">
          <div *ngFor="let child of obj.navigableProperties">
            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{{child}}
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="col-sm-6 connection">
    <div class="row connection_header">
      <div class="col-lg-11">
        <span id='destinationConnections'>
          <kendo-dropdownlist [data]="destinationConnections" class="custom_dpd" height="40" [filterable]="true"
            [textField]="'name'" [valueField]="'connectionId'" (filterChange)="filterDestinationConnection($event)"
            [(ngModel)]="destinationConnectionValue" *ngIf="!isDestinationConnectionConnected"
            (selectionChange)="selectionChangeDestinationConnection($event)" >
          </kendo-dropdownlist>
        </span>
        <span id="selectTableCollection">
          <kendo-dropdownlist [data]="destinationCollection" [filterable]="true" [textField]="'text'"
            [valueField]="'value'" (filterChange)="filterDestinationCollection($event)"
            [(ngModel)]="destinationCollectionValue" (selectionChange)="selectionChangeDestinationCollection($event)"
            *ngIf="isDestinationConnectionConnected" [disabled]="destinationConnectionValue.type==='EXCEL'">
          </kendo-dropdownlist>
        </span>
      </div>
      <div class="col-lg-1 no-padding text-center">
        <span id='destinationConnectionsBtn'>
          <button kendoButton class="k-button-default" *ngIf="!isDestinationConnectionConnected"
            (click)="selectionChangeDestinationConnection()">
            <svg class="icon_ok" shape-rendering="geometricPrecision" width="20" height="20" fill="#0067C5">
              <use xlink:href="./assets/dist/img/icons.svg#icon_ok"></use>
            </svg>
          </button>
        </span>
        <span id="createTableBtn">
          <button #destiConnection kendoButton (click)="onToggleDestinationConnection(isDestinationConnectionOption)"
            class="k-button-default option" *ngIf="isDestinationConnectionConnected">
            <svg class="icon_connection" shape-rendering="geometricPrecision" width="20" height="20">
              <use xlink:href="./assets/dist/img/icons.svg#icon_vertical_dots"></use>
            </svg>
          </button>
        </span>
        <span id="createTableOption">
          <kendo-popup [anchor]="destiConnection" *ngIf="isDestinationConnectionOption"
            class="destination-connection-option" style="left: 0px !important">
            <ul class="nav nav-list">
              <li>
                <a href="javascript:void(0)" (click)="changeDestinationConnection()" class="changelog white">
                  <svg class="icon_change_log" shape-rendering="geometricPrecision" width="20" height="20">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_change_log"></use>
                  </svg> Change Connection
                </a>
              </li>

              <li *ngIf = "destinationConnectionValue.type !== 'API' && (destinationValueType!=='EXCEL') && (destinationValueType!=='DataHug')">
                <a href="javascript:void(0)" [attr.disabled]="isDestinationCollectionSelected ? true: null"
                  (click)="copyMetadata();onToggleDestinationConnection(isDestinationConnectionOption)"
                  class="changelog white">
                  <svg class="icon_change_log" shape-rendering="geometricPrecision" width="20" height="20">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_table"></use>
                  </svg> Create Table
                </a>
              </li>

              <li *ngIf = "destinationValueType!=='EXCEL' && (destinationValueType!=='DataHug')"> 
                <a href="javascript:void(0)"
                  (click)="autoLinking();onToggleDestinationConnection(isDestinationConnectionOption)"
                  class="changelog white">
                  <svg class="icon_change_log" shape-rendering="geometricPrecision" width="20" height="20">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_linking"></use>
                  </svg> Auto Link
                </a>
              </li>
              <li *ngIf = "destinationValueType!=='EXCEL' && (destinationValueType!=='DataHug')">
                <a href="javascript:void(0)" (click)="openTab('dataPreviewer')" class="changelog white">
                  <svg class="icon_update" shape-rendering="geometricPrecision" width="15" height="15">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_viwer"></use>
                  </svg> Data Previewer
                </a>
              </li>
              <li *ngIf = "destinationValueType!=='EXCEL' && (destinationValueType!=='DataHug')">
                <a href="javascript:void(0)" (click)="refreshMetadata()" (click)="refreshDestinationMetadata()"
                  class="changelog white">
                  <svg class="icon_update" shape-rendering="geometricPrecision" width="15" height="15">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_refresh"></use>
                  </svg> Refresh Metadata
                </a>
              </li>
            </ul>
          </kendo-popup>
        </span>
      </div>
    </div>
    <div class="connection_message">
      <div class="message1" *ngIf="!isDestinationConnectionConnected">
        Choose destination connection by clicking above icon
        <svg class="icon_add_item" shape-rendering="geometricPrecision" width="20" height="20" fill="#0067C5">
          <use xlink:href="./assets/dist/img/icons.svg#icon_add_item"></use>
        </svg>
      </div>
      <div class="message2" *ngIf="(isDestinationConnectionConnected && !isDestinationCollectionSelected) &&  (destinationValueType!=='EXCEL') && (destinationValueType!=='DataHug')">
        Select collection name from above collection dropdown or Create new table.
      </div>
    </div>
    <span id="OkBtn">
      <div class="row" *ngIf="isCreateTableRequested">
        <div class="col-md-12">

          <div class="box box-warning box-solid"
            style="margin-bottom: 0;margin-top: 3px;box-shadow: 0px 0px 5px 0px #666;">
            <div class="box-header with-border" style="padding: 4px 10px">
              <h3 class="box-title" style="font-size: 12px">Alert</h3>
              <!-- /.box-tools -->
            </div>
            <!-- /.box-header -->

            <div class="box-body" style="margin: 0;font-size: 12px;">

              <p>Are you sure want to create new table with name of {{selectedDestinationCollection[0].collectionName}}
                <span class="label label-warning"
                  style="margin-left: 5px">({{selectedDestinationCollection[0].collectionName.length}}) </span>
              </p>

              <div class="box-tools pull-right">
                <button type="button" class="btn btn-default btn-box-tool" data-widget="collapse"
                  [disabled]="selectedDestinationCollection[0].collectionName.length > 30" (click)="createTable()">Ok
                </button>&nbsp;
                <button type="button" class="btn btn-default btn-box-tool" (click)="clearCopyTable()"
                  data-widget="collapse">Cancel
                </button>
              </div>

            </div>

            <!-- /.box-body -->
          </div>

          <!-- /.box -->
        </div>
      </div>
    </span>

    <div *ngIf="isDestinationConnectionConnected && isDestinationCollectionSelected">
      <div class="collection" *ngFor="let obj of selectedDestinationCollection">
        <div class="name" [ngClass]="{'error' : obj.collectionName.length >30 ? obj.isNameError : ''}">
          <span *ngIf="!obj.toggleName && !obj.isNameError">{{obj.collectionName}}</span>
          <input kendoInput type="text" *ngIf="obj.toggleName || obj.isNameError" placeholder="Collection Name"
            class="column_name" [(ngModel)]="obj.collectionName"   (input)="tableName(obj)" />
          <button kendoButton class="k-button-default option" *ngIf="(destinationConnectionValue.type !== 'API')  &&  (!obj.toggleName || obj.isNameError)"
            (click)="obj.toggleName = !obj.toggleName">
            <svg class="icon_edit pull-right" shape-rendering="geometricPrecision" width="15" height="15">
              <use xlink:href="./assets/dist/img/icons.svg#icon_edit"></use>
            </svg>
          </button>
          <button kendoButton class="k-button-default option okBtn" (click)="obj.toggleName = !obj.toggleName"
            *ngIf="obj.toggleName || obj.isNameError">
            <svg class="icon_ok pull-right" shape-rendering="geometricPrecision" width="15" height="15">
              <use xlink:href="./assets/dist/img/icons.svg#icon_ok"></use>
            </svg>
          </button>
          <span class="label label-warning" style="margin-left: 5px">({{obj.collectionName.length}}) </span>
        </div>
        <div *ngIf="!isCreatedTableRequest">
          <!-- [ngClass]="{'error' : metadata.name.length > 30, 'error' : metadata.isNameError === true}" -->
          <div [ngClass]="{'error' : metadata.name.length > 30, 'error' : metadata.isNameError === true}"
            class="columns" mwlDroppable (drop)="onDrop($event, i)"
            *ngFor="let metadata of obj.collectionMetadataResponseList;let i = index">
            <div class="name">
              <span *ngIf="!metadata.isNameError && !metadata.toggleName">{{metadata.name}}</span>
              <small class="label label-success" *ngIf="metadata.isNewColumn">New</small>
              <input *ngIf="metadata.isNameError || metadata.toggleName" kendoInput type="text"
                placeholder="COLUMN NAME" class="column_name" [(ngModel)]="metadata.name"
                (input)="checkColumnName(metadata)" />
              <button kendoButton class="k-button-default option" *ngIf="(destinationConnectionValue.type !== 'API') && (destinationConnectionValue.type !== 'ODATA') && (!metadata.toggleName || metadata.isNameError)"
                (click)="metadata.toggleName = !metadata.toggleName">
                <svg class="icon_edit pull-right" shape-rendering="geometricPrecision" width="15" height="15">
                  <use xlink:href="./assets/dist/img/icons.svg#icon_edit"></use>
                </svg>
              </button>
              <!-- <button kendoButton kendoTooltip class="k-button-default option"
                  *ngIf="!metadata.toggleName && metadata.isNameError">
                  <svg class="icon_edit pull-right" shape-rendering="geometricPrecision" width="15" height="15"
                    [attr.title]="metadata.name + ' should not exceed the 30 character length'">
                    <use xlink:href="./assets/dist/img/icons.svg#icon_error"></use>
                  </svg>
                </button> -->
              <button kendoButton class="k-button-default option okBtn"
                (click)="metadata.toggleName = !metadata.toggleName"
                *ngIf="metadata.toggleName || metadata.isNameError">
                <svg class="icon_ok pull-right" shape-rendering="geometricPrecision" width="15" height="15">
                  <use xlink:href="./assets/dist/img/icons.svg#icon_ok"></use>
                </svg>
              </button>
              <span class="label label-warning" style="margin-left: 5px">({{metadata.name.length}})</span>
            </div>
            <div class="type">
              <span *ngIf="!metadata.toggleType">{{metadata.type}}</span>
              <kendo-dropdownlist [data]="typeCollection" [filterable]="true" [textField]="'text'"
                [valueField]="'value'" (filterChange)="handleFilter($event)" class="column_type"
                *ngIf="metadata.toggleType">
              </kendo-dropdownlist>
            </div>
            <div class="mapping">
              <input [disabled]="metadata.updatable==='false'" kendoInput type="text" class="job_name" (input)="changeMetaMapping(metadata.mapping, i)" [ngModel]="metadata.mapping">
              <small class="label label-success" *ngIf="metadata.updatable==='false'">Non Editable </small>
            
            </div>

          </div>
        </div>
      </div>
    </div>
  </div>
</section>
<kendo-dialog title="" *ngIf="opened" (close)="close('cancel')" [width]="1300" [height]="height">
  <kendo-dialog-titlebar>
    <div style="font-size: 18px; line-height: 1.3em;">
      <span class="k-icon k-i-warning"></span> Delete Data
    </div>
  </kendo-dialog-titlebar>
  <kendo-tabstrip (tabSelect)="onTabSelect($event)">
    <kendo-tabstrip-tab [title]="'Net Change'" [selected]="selectedModelTabName === 'netChange'">
      <ng-template kendoTabContent>
        <!-- <input type="radio" name="allProcess" id="allProcess" class="k-radio" (change)="isIncrementParameter = false"
            [(ngModel)]="incrementValue" value="singleProcess"> -->
        <div class="k-form-field">
          <input type="radio" name="allProcess" id="allProcess" class="k-radio" [(ngModel)]="incrementValue"
            value="singleProcess" (change)="handleChange($event)">
          <label class="k-radio-label" for="allProcess">Process all records on each run.</label>
          <div class="top-Margin"></div>
          <span id="radioBtn">
            <input type="radio" name="allProcess" id="incrementProcess" class="k-radio" (change)="handleChange($event)"
              [(ngModel)]="incrementValue" value="allProcess">
          </span>
          <label class="k-radio-label" for="incrementProcess">Process only records created or updated since the
            last
            run, based on the value of the specified field.</label>
        </div>
        <div class="top-Margin"></div>
        <span id="selectNetChaneValue">
          <kendo-dropdownlist [data]="incrementalColumns" style="width: 100%;"
            [(ngModel)]="incrementalColumnSelectedValue" *ngIf="isIncrementParameter">
          </kendo-dropdownlist>
        </span>
        <div class="top-Margin"></div>
        <div *ngIf="isIncrementParameter">
          <p>Most Recent Record Processed:<strong (click)='incrementColumnDateTimeValue = false'>
              Never</strong>&nbsp;<a href="javascript:void(0)" (click)='incrementColumnDateTimeValue = true'
              *ngIf="incrementalColumnSelectedValue">DateTime</a>
        </div>
        <span id="selectIncrementDate">
          <kendo-datepicker [(value)]="incrementColumnValue" *ngIf="incrementalColumnSelectedValue">
          </kendo-datepicker>
        </span>
        <span id="selectIncrementTime">
          <kendo-timepicker [(value)]="incrementColumnValue" *ngIf="incrementalColumnSelectedValue">
          </kendo-timepicker>
        </span>
        <div class="top-Margin"></div>
        <p *ngIf="isIncrementParameter"><strong>Note</strong>: Net Change field and datetime filters are appended
          to the
          list
          of
          filters configured on the Filter tab as an
          AND.</p>
      </ng-template>
    </kendo-tabstrip-tab>
    <kendo-tabstrip-tab [title]="'Filter'" [selected]="selectedModelTabName === 'filter'">
      <ng-template kendoTabContent>
        <table class="table table-striped d_filter" *ngIf="sourceCollectionValue.subcategory!=='procedure'">
          <tr>
            <th></th>
            <th>And/Or</th>
            <th>Field</th>
            <th>Data Type</th>
            <th>Operator</th>
            <th>Value</th>

          </tr>
          <tr *ngFor="let filter of dataFilters; let i = index">
            <td class="control" width="100px">
              <button kendoButton>
                <svg class="icon_add_item" shape-rendering="geometricPrecision" width="20" height="20" fill="#0067C5"
                  (click)="addFilter()">
                  <use xlink:href="./assets/dist/img/icons.svg#icon_add_item"></use>
                </svg>
              </button>
              <button kendoButton *ngIf="i !== 0">
                <svg class="icon_add_item" shape-rendering="geometricPrecision" width="20" height="20"
                  style="fill: #C50000" (click)="removeFilter(i)">
                  <use xlink:href="./assets/dist/img/icons.svg#icon_delete"></use>
                </svg>
              </button>
            </td>

            <td class="input" width="100px">
              <kendo-dropdownlist [data]="logicalOperatorCollections" class="custom_dpd" height="40"
                [defaultItem]="{ text: 'Select Operator', value: 'null' }" [textField]="'text'" [valueField]="'text'"
                [valuePrimitive]="true" [(ngModel)]="filter.logicalOperator" [disabled]="i == 0">
              </kendo-dropdownlist>

            </td>

            <td class="input" width="100px">
              <span id="filterField">
                <kendo-dropdownlist [data]="sourceFilterableColumns" [textField]="'name'" [valueField]="'name'"
                  (selectionChange)="selectionChangeDataType($event, filter)" [(ngModel)]="filter.field"
                  [valuePrimitive]="true">
                </kendo-dropdownlist>
              </span>
            </td>
            <td class="input" width="100px">
              <input kendoInput placeholder="Data Type" [(ngModel)]="filter.dataType" />
            </td>
            <td class="input" id="selectOperator" width="100px">
              <kendo-dropdownlist [data]="comparisonOperatorCollections" class="custom_dpd" height="40"
                [filterable]="true" [textField]="'value'" [valueField]="'text'" [valuePrimitive]="true"
                [(ngModel)]="filter.comparisonOperator">
              </kendo-dropdownlist>
            </td>
            <td class="input" width="100px">
              <input kendoInput placeholder="Value" [(ngModel)]="filter.value" />
            </td>
          </tr>
        </table>
        <table class="table table-striped d_filter" *ngIf="sourceCollectionValue.subcategory==='procedure'">
          <tr>

            <th>And/Or</th>
            <th>Field</th>
            <th>Data Type</th>
            <th>Operator</th>
            <th>Value</th>

          </tr>
          <tr *ngFor="let filter of dataFilters; let i = index">


            <td class="input" width="100px">
              <kendo-dropdownlist [data]="logicalOperatorCollections" class="custom_dpd" height="40"
                [defaultItem]="{ text: 'Select Operator', value: 'null' }" [textField]="'text'" [valueField]="'text'"
                [valuePrimitive]="true" [(ngModel)]="filter.logicalOperator" [disabled]="i == 0">
              </kendo-dropdownlist>

            </td>

            <td class="input" width="100px">
              <span id="filterField">
                <kendo-dropdownlist [data]="sourceFilterableColumns" [textField]="'name'" [valueField]="'name'"
                  (selectionChange)="selectionChangeDataType($event, filter)" [(ngModel)]="filter.field"
                  [valuePrimitive]="true" disabled>
                </kendo-dropdownlist>
              </span>
            </td>
            <td class="input" width="100px">
              <input kendoInput placeholder="Data Type" [(ngModel)]="filter.dataType" disabled />
            </td>
            <td class="input" id="selectOperator" width="100px">
              <kendo-dropdownlist [data]="comparisonOperatorCollections" class="custom_dpd" height="40"
                [filterable]="true" [textField]="'value'" [valueField]="'text'" [valuePrimitive]="true"
                [(ngModel)]="filter.comparisonOperator">
              </kendo-dropdownlist>
            </td>
            <td class="input" width="100px">
              <input kendoInput placeholder="Value" [(ngModel)]="filter.value" />
            </td>
          </tr>
        </table>


        <!-- <span  id = "Validate Filter" > -->
        <button kendoButton id="validate" (click)="validateFilter()" [primary]="true">Validate Filter</button>
        <!-- </span> -->
      </ng-template>
    </kendo-tabstrip-tab>
    <kendo-tabstrip-tab [title]="'Data Previewer'" [selected]="selectedModelTabName === 'dataPreviewer'">
      <ng-template kendoTabContent>
        <table class="table table-striped d_filter" style="margin:0px">
          <tr>
            <th></th>
            <th>And/Or</th>
            <th>Field</th>
            <th>Data Type</th>
            <th>Operator</th>
            <th>Value</th>
          </tr>
          <tr *ngFor="let filter of dataPreviewerFilters; let i = index">
            <td class="control" width="100px">
              <button kendoButton>
                <svg class="icon_add_item" shape-rendering="geometricPrecision" width="20" height="20" fill="#0067C5"
                  (click)="addDataPreviewerFilters()">
                  <use xlink:href="./assets/dist/img/icons.svg#icon_add_item"></use>
                </svg>
              </button>
              <button kendoButton *ngIf="i !== 0">
                <svg class="icon_add_item" shape-rendering="geometricPrecision" width="20" height="20"
                  style="fill: #C50000" (click)="removeDataPreviewerFilters(i)">
                  <use xlink:href="./assets/dist/img/icons.svg#icon_delete"></use>
                </svg>
              </button>
            </td>
            <td class="input" width="100px">
              <kendo-dropdownlist [data]="logicalOperatorCollections" class="custom_dpd" height="40" [filterable]="true"
                [textField]="'text'" [valueField]="'text'" [valuePrimitive]="true" [(ngModel)]="filter.logicalOperator">
              </kendo-dropdownlist>
            </td>
            <td class="input" width="100px">
              <span id="filterField">
                <kendo-dropdownlist [data]="sourceFilterableColumns" [textField]="'name'" [valueField]="'name'"
                  (selectionChange)="selectionChangeDataType($event, filter)" [(ngModel)]="filter.field"
                  [valuePrimitive]="true">
                </kendo-dropdownlist>
              </span>
            </td>
            <td class="input" width="100px">
              <input kendoInput placeholder="Data Type" [(ngModel)]="filter.dataType" disabled />
            </td>
            <td class="input" width="100px">

              <kendo-dropdownlist [data]="comparisonOperatorCollections" class="custom_dpd" height="40"
                [filterable]="true" [textField]="'value'" [valueField]="'text'" [valuePrimitive]="true"
                [(ngModel)]="filter.comparisonOperator">
              </kendo-dropdownlist>
            </td>
            <td class="input" width="100px">
              <input kendoInput id="writeValue" placeholder="Value" [(ngModel)]="filter.value" />
            </td>
          </tr>
        </table>
        <button kendoButton type="button" (click)="getDataForPreview()" [primary]="true">Filter</button>
        <kendo-tabstrip>
          <kendo-tabstrip-tab
            [title]="sourceCollection?.length > 0 ? sourceCollectionValue?.value + ' (' +sourceConnectionValue.name + ')':''"
            [selected]="true" [disabled]="sourceCollectionValue?.value == 0?true:false">
            <ng-template kendoTabContent>
              <kendo-grid [data]="sourceGridDataResult" [height]="430" [pageable]="true"
                (pageChange)="sourceItemsPageChange($event)" [sortable]=" { allowUnsort: true}" [pageSize]="state.take"
                [skip]="state.skip" [sort]="state.sort" [filter]="state.filter" [sortable]="true" [pageable]="{
                    buttonCount: buttonCount,
                    info: infoDP,
                    type: typeDP,
                    pageSizes: pageSizesDP,
                    previousNext: previousNextDP
                  }" [filter]="netNewFilter" [loading]="sourceGridLoading">
                <kendo-grid-column kendoTooltip position="right" field="Name" title="Name">
                </kendo-grid-column>
                <kendo-grid-column kendoTooltip position="right" field="Value" title="Value">
                </kendo-grid-column>
              </kendo-grid>
            </ng-template>
          </kendo-tabstrip-tab>
          <kendo-tabstrip-tab
            [title]="destinationCollection?.length > 0 ? destinationCollectionValue?.value + ' (' + destinationConnectionValue?.name + ')':''"
            [disabled]="destinationCollectionValue?.value == 0?true:false">
            <ng-template kendoTabContent>
              <kendo-grid [data]="destinationGridDataResult" [height]="430" [pageable]="true" [resizable]="true"
                (pageChange)="destinationItemsPageChange($event)" [sortable]=" { allowUnsort: true}"
                [pageSize]="state.take" [skip]="state.skip" [sort]="state.sort" [filter]="state.filter"
                [sortable]="true" [pageable]="{
                    buttonCount: buttonCount,
                    info: infoDP,
                    type: typeDP,
                    pageSizes: pageSizesDP,
                    previousNext: previousNextDP
                  }" [filter]="netNewFilter" [loading]="destinationGridLoading">
                <kendo-grid-column kendoTooltip position="right" field="Name" title="Name">
                </kendo-grid-column>
                <kendo-grid-column kendoTooltip position="right" field="Value" title="Value">
                </kendo-grid-column>
              </kendo-grid>
            </ng-template>
          </kendo-tabstrip-tab>
        </kendo-tabstrip>
      </ng-template>
    </kendo-tabstrip-tab>
    <kendo-tabstrip-tab [title]="'View Log'" [selected]="selectedModelTabName === 'logView'">
      <ng-template kendoTabContent>
        <app-log [job]="jobRequest"></app-log>
      </ng-template>
    </kendo-tabstrip-tab>
  </kendo-tabstrip>
  <kendo-dialog-actions layout="normal">
    <!-- <button kendoButton (click)="validateFilter()" [primary]="true">Validate Filter</button> -->

    <button kendoButton (click)="saveTabOptions()" id="OkBtn" [primary]="true">Ok</button>

  </kendo-dialog-actions>
</kendo-dialog>
<!-- <div mwlDraggable (dragEnd)="dragEnd($event)" *ngFor="let track of metadatName">
  {{track}}
</div>
<div mwlDroppable (drop)="onDrop($event, i)" *ngFor="let track of metadataName; let i = index">
  <div style="width: 100%">{{track}}</div>
  <input type="text" [(ngModel)]="track" />
</div> -->